package cn.com.infosec.jce;

import cn.com.infosec.math.ec.ECCurve;
import java.math.BigInteger;
import java.security.spec.ECFieldF2m;
import java.security.spec.ECFieldFp;
import java.security.spec.ECPoint;
import java.security.spec.EllipticCurve;

public class ECPointUtil {
   public static ECPoint decodePoint(EllipticCurve curve, byte[] encoded) {
      BigInteger var4;
      Object var13;
      EllipticCurve var10001;
      EllipticCurve var10002;
      if (curve.getField() instanceof ECFieldFp) {
         ECCurve.Fp var2;
         ECCurve.Fp var10000 = var2 = new ECCurve.Fp;
         var10001 = curve;
         var10002 = curve;
         BigInteger curve1 = ((ECFieldFp)curve.getField()).getP();
         BigInteger var3 = var10002.getA();
         var4 = var10001.getB();
         var10000.<init>(curve1, var3, var4);
         var13 = var2;
      } else {
         int curve2;
         int[] var11;
         int var12;
         Object var16;
         if ((var11 = ((ECFieldF2m)curve.getField()).getMidTermsOfReductionPolynomial()).length == 3) {
            var16 = var13 = new ECCurve.F2m;
            var10001 = curve;
            var10002 = curve;
            int[] var10003 = var11;
            int[] var10004 = var11;
            curve2 = ((ECFieldF2m)curve.getField()).getM();
            var12 = var11[2];
            int var14 = var10004[1];
            int var5 = var10003[0];
            BigInteger var6 = var10002.getA();
            BigInteger var7 = var10001.getB();
            var16.<init>(curve2, var12, var14, var5, var6, var7);
         } else {
            var16 = var13 = new ECCurve.F2m;
            var10001 = curve;
            var10002 = curve;
            curve2 = ((ECFieldF2m)curve.getField()).getM();
            var12 = var11[0];
            var4 = var10002.getA();
            BigInteger var15 = var10001.getB();
            var16.<init>(curve2, var12, var4, var15);
         }
      }

      cn.com.infosec.math.ec.ECPoint curve3 = ((ECCurve)var13).decodePoint(encoded);
      return new ECPoint(curve3.getX().toBigInteger(), curve3.getY().toBigInteger());
   }
}
